package GajaDiary::Article;
use strict;

my $BASE_URI = "http://white.niu.ne.jp/Freetalk/";

sub parse{
    my($topic,$ptr,$comments,$body);
    my $class = shift;
    my $src   = shift;
    foreach(split(/\n/,$src)){
	if(/<div class=([\'\"])Article\1>/){
	}elsif(m{<h4>.*?@</a>(.*?)</h4>}){
	    $topic = $1;
	}elsif(m{^<p class='advance_ptr'><a href='article.cgi\?(.*?)'>\+comment\((\d+)\)}){
	    $ptr = $1;
	    $comments = $2;
	    last;
	}else{
	    $body .= "$_\n";
	}
    }
    return bless {
	topic    => $topic,
	ptr      => $ptr,
	comments => $comments,
	body     => $body
	},$class;
}

sub body{
    my $self = shift;
    my $result = \$self->{body};
    if(@_){
	$self->{body} = shift;
    }
    return $$result;
}

sub topic{
    my $self = shift;
    my $result = \$self->{topic};
    if(@_){
	$self->{topic} = shift;
    }
    return $$result;
}

sub ptr{
    my $self = shift;
    my $result = \$self->{ptr};
    if(@_){
	$self->{ptr} = shift;
    }
    return $$result;
}

sub comments{
    my $self = shift;
    my $result = \$self->{comments};
    if(@_){
	$self->{comments} = shift;
    }
    return $$result;
}

sub rss_description{
    my $self = shift;
    my $result = $self->body;
    $result =~ s/<pre>.*?<\/pre>/.../sg;
    $result =~ s/<.*?>//sg;
    return $result;
}

sub dc_date{
    my $self = shift;
    $self->ptr() =~ /^(\d{2})(\d{2})(.)(\d{2})(\d{2})(\d{2})/;
    my($year,$month,$day,$hour,$min) = ($1,$2,$4,$5,$6);
    return sprintf("20%02d-%02d-%02dT%02d:%02d+09:00"
		   ,$year,$month,$day,$hour,$min);
}

sub as_string{
    my $self = shift;
    return sprintf("<div class='Article'>\n<h4><a href='%s' name='%s'>@</a>%s</h4>\n%s<p class='advance_ptr'><a href='article.cgi?%s'>+comment(%d)</a></p>\n</div>\n",$self->ptr,$self->ptr,,$self->topic,$self->body,$self->ptr,$self->comments);
}

sub as_rdf_li{
    my $self = shift;
    my $uri = sprintf("%sarticle.cgi?%s",$BASE_URI,$self->ptr);
    return sprintf("<rdf:li rdf:resource=\"%s\" />",$uri);
}

sub as_RSSitem{
    my $self = shift;
    my $uri = sprintf("%sarticle.cgi?%s",$BASE_URI,$self->ptr);
    return sprintf(q{
<item rdf:about="%s">
 <title>%s</title>
 <link>%s</link>
 <description>%s</description>
 <dc:date>%s</dc:date>
</item>
},$uri,$self->topic,$uri,$self->rss_description,$self->dc_date);
}
1;
