#!/usr/bin/perl

require "jcode.pl";
require "libgajadiary.pl";
require "libmyftp.pl";
require ".gajadiary/config";

$cofile = "./.checkout";
@baselist = qw( index.html gajaf.idx topicindex .gajadiary/alias
		backnumberlist.html FREETALK.css template.html About.html);
push(@baselist,$libgajadiary::logfile);

use Getopt::Long;
GetOptions('help'   => \$opt{help},
	   'fetch'  => \$opt{fetch},
	   'put'    => \$opt{put},
	   'update' => \$opt{update},
	   'noput'  => \$opt{noput},
	   'test'   => \$opt{test},
	   'add=s'  => \$opt{add},
	   'down=s'  => \$opt{down});

if($opt{help} == 1){
    print "$0 [--noput] [--fetch] [--put] [--update] [--help]\n";
    print "    --help      : Show this message\n";
    print "    --fetch     : Fetch current files from primary site.\n";
    print "    --update    : Update local files.\n";
    print "    --put       : Put local files to each web site.\n";
    print "    --noput     : means ' --fetch --update '\n";
    print "    --add file  : Force upload 'file' when putting.\n";
    print "    --down file : Download 'file' when fetch\n";
    print "    (no option) : means ' --fetch --update --put '\n";
    exit(0);
}

$flag = 1; grep { $flag = 0 if($_ == 1) } values %opt;

if($flag == 1){
    $opt{fetch}  = 1;
    $opt{update} = 1;
    $opt{put}    = 1;
}
if($opt{noput} == 1){
    $opt{fetch}  = 1;
    $opt{update} = 1;
}

if($opt{test}){
    &libgajadiary::setCommit(0);
    &libgajadiary::readAliasFile();
    &libgajadiary::readNewArticle();
    &libgajadiary::showNewArticle('euc');
    exit(0);
}    


$primary = 1;
foreach my $host (@hosts){
    $hostname = $host->[1];
    $user     = $host->[2];
    $cwd      = $host->[3];
    $passwd   = $host->[4];

    print "$hostname : $user : $cwd : $primary\n";
    # only for primary host.
    if($primary == 1){
	if($opt{fetch}){
	    &myftp::OPEN(COM,$hostname,$user,$passwd);
	    $opened = 1;
	    &myftp::CWD(COM,$cwd);
	    push(@baselist,$opt{down}) if($opt{down});
	    foreach(@baselist){
		&myftp::GET(COM,$_);
	    }
	    timestamp($cofile);
	}

	if($opt{update}){
	    sleep(1);
	    &libgajadiary::readAliasFile();
	    &libgajadiary::readNewArticle();
	    &libgajadiary::renewDigest();
	    &libgajadiary::renewLog();
	    &libgajadiary::renewSignature();
	    system("./mkRSS.pl > index.rss10");
	}
	push(@baselist,"index.rss10");
	if($opt{put}){
	    $checkout = (stat($cofile))[9];
	    foreach(@baselist){
		my $time = (stat("./$_"))[9];
		print "$_ : $checkout / $time\n";
		push(@renewlist,$_) if($checkout <= $time );
	    }
	    push(@renewlist,$opt{add}) if ($opt{add});
	    print "No file renewed.\n" if(!@renewlist);
	    timestamp($cofile);
	}
    }

    # foreach hosts.
    if($opt{put} && @renewlist){
	if(not $opened){
	    &myftp::OPEN(COM,$hostname,$user,$passwd);
	    $opened = 1;
	    &myftp::CWD(COM,$cwd);
	}
	
	foreach(@renewlist){
	    &myftp::PUT(COM,$_);
	}
    }

    &myftp::CLOSE(COM) if $opened;
    $opened = 0;
    $primary = 0;
}


exit(0);

sub timestamp{
    my($file) = @_;
    open(TOUCH,"> $file");
    print TOUCH time();
    close($file);
}
