package myftp;

$libname = "myftp";
$update  = "20010206";

use Socket;
use FileHandle;

1;

sub OPEN
{
    local($COM,$host,$user,$passwd) = @_;
    $COMhost = $host;
    ftp_open($COM,$host);
    ftp_recv($COM);
    ftp_auth($COM,$user,$passwd);
}

sub LIST
{
    local($COM) = @_;
    &ftp_PASV($COM);
    &ftp_send($COM, 'LIST');
    &ftp_recvdata($COM);
}
sub CWD
{
    local($COM,$path) = @_;
    &ftp_send($COM, 'CWD',$path);
    &ftp_recv($COM);
}
sub GET
{
    local($COM,$file) = @_;
    &ftp_TYPE($COM,"I");
    &ftp_PASV($COM);
    &ftp_RETR($COM,$file);
}
sub PUT
{
    local($COM,$file) = @_;
    &ftp_TYPE($COM,"I");
    &ftp_PASV($COM);
    &ftp_STOR($COM,$file);
}

sub CLOSE
{
    local($COM) = @_;
    &ftp_send($COM, 'QUIT');
    &ftp_recv($COM);
    &ftp_close($COM);
}

sub getfile
{
}

sub ftp_open {
    local($COM,$host,$port) = @_;
    local($ip, $sockaddr);
    
    if ($host eq '') { $host = 'localhost'; }
    if ($port eq '') { $port = getservbyname('ftp', 'tcp');}
    
    # make socket
    $ip = inet_aton($host) || die "host($host) not found.\n";
    $sockaddr = pack_sockaddr_in($port, $ip);
    socket($COM, PF_INET, SOCK_STREAM, 0) || die "socket error.\n";
    
    # do connect
    connect($COM, $sockaddr) || die "connect $host $port error.\n";
    $COM->autoflush(1);
}

sub ftp_auth
{
    my($COM,$user,$pass) = @_;

    # send username
    &ftp_send($COM, 'USER', $user);
    &ftp_recv($COM);
    
    # send password
    if(!$passwd){
	system("stty -echo >/dev/null 2>&1");
	print "Password: "; chomp($pass= <>);
	system("stty echo >/dev/null 2>&1");
    }
    print "\nPASS XXXX\n";
    print $COM "PASS $pass\n";
    $buf = &ftp_recv($COM);
    if ($buf =~ /^5/) { exit; }
}

# FTP$B@\B3=*N;(B
sub ftp_close {
  my ($COM) = @_;

  close($COM);
}

sub ftp_PASV
{
    local($COM) = @_;
    &ftp_send($COM, 'PASV');
    $buf = &ftp_recv($COM);
    $buf =~ /^2\d\d .*\((\d+,\d+,\d+,\d+),(\d+),(\d+)\)/;
    $datahost = $1;
    $dataport = $2 * 256 + $3;
    $datahost =~ s/,/\./g;
}

sub ftp_TYPE
{
    local($COM,$type) = @_;
    &ftp_send($COM, 'TYPE',$type);
    $buf = &ftp_recv($COM);
}

sub ftp_RETR
{
    local($COM,$file) = @_;
    local($data,$pid);
    &ftp_send($COM, 'RETR',$file);
    if ($pid = fork()) { # parent
	$buf = &ftp_recv($COM);
	if($buf =~ /^5/){
	    kill 9,$pid;
	}else{
	    wait;
	    &ftp_recv($COM);
	}
    } else { # child
	&ftp_open(DATA, $datahost, $dataport);
	while(<DATA>){
	    $data .= $_;
	}
	close(DATA);
	open(OUT,"> $file");
	print OUT $data;
	close(OUT);
	exit(0);
    }
}

sub ftp_STOR
{
    local($COM,$file) = @_;
    local($data,$pid);
    open(IN,"$file");
    &ftp_send($COM, 'STOR',$file);
    if ($pid = fork()) { # parent
	$buf = &ftp_recv($COM);
	if($buf =~ /^5/){
	    kill 9,$pid;
	}else{
	    wait;
	    &ftp_recv($COM);
	}
    } else { # child
	&ftp_open(DATA, $datahost, $dataport);
	while(<IN>){
	    print DATA $_;
	}
	close(IN);
	close(DATA);
	exit(0);
    }
}

sub ftp_recvdata
{
    local($COM,$evallist) = @_;
    local($data,$pid);
    if ($pid = fork()) { # parent
	$buf = &ftp_recv($COM);
	if($buf =~ /^5/){
	    kill 9,$pid;
	}else{
	    wait;
	    &ftp_recv($COM,'here');
	}
    } else { # child
	&ftp_open(DATA, $datahost, $dataport);
	while ($buf=<DATA>) {
	    $data .= $buf;
	}
	close(DATA);
	exit(0);
    }
}

# FTP$B%3%^%s%IAw?.(B
sub ftp_send {
  my ($COM, $cmd, @opt) = @_;

  if ($#opt) {
    print "$cmd\n";
    print $COM "$cmd\n";
  } else {
    print "$cmd @opt\n";
    print $COM "$cmd @opt\n";
  }
}

# FTP$B%l%9%]%s%9<u?.(B
sub ftp_recv {
  my ($COM) = @_;
  my ($buf, $rc, $cont, $msg);

  $rc = 0;
  while (chomp($buf=<$COM>)) {
    print "$buf\n";
    $buf =~ /^(\d\d\d)([ |-])(.*)/;
    $rc = $1; $cont = $2; $msg = $3;
    if ($cont ne '-') { last; }
  }
  return($buf);
}
